# $Id: ndiary-lib.rb,v 1.48 2003/09/05 19:07:49 not Exp $
#mainρBύX_FARGVargv

ONDIARY_VERSION = 'on the Web v.20040201'

def main ( argv = [] )

  print "\n-- #{NDIARY_VERSION} --\n\n"
  now = Time::now

  begin
    ndiary = NDiary::new

    # Load Configuration
    if /.+\.conf$/i =~ argv[0] or /\.ndiaryrc$/ =~ argv[0] then
      configfile = argv.shift
    else
      configfile = ENV['HOME'].to_s + File::Separator + ".ndiaryrc";
      unless File::readable? configfile then
        configfile = 'ndiary.conf'
      end
    end

    ndiary.loadconfig(configfile)

    # commandline option
    while argv[0].to_s[0,1] == "-" do
      opt = argv.shift.dup
      opt.sub!(/^\-/, '')
      key, value = opt.split('=', 2)
    
      ndiary.setconfig(key, value)
    end

    # make diary html file
    if argv.size.zero? then
      ndiary.makepastdiary
      ndiary.makelastdiary

    elsif /^(\d{6})$/ =~ argv[0] then
      ndiary.makepastdiary($1)

    elsif /^(\d{4})$/ =~ argv[0] then
      for m in '01'..'12'
        ndiary.makepastdiary($1 + m)
      end

    elsif /^(\d{6})\-(\d{6})$/ =~ argv[0] then
      ym1, ym2 = $1, $2
      if ym1 > ym2 then
        ym1, ym2 = ym2, ym1
      end
      
      y1, m1 = ym1[0..3], ym1[4..5]
      y2 ,m2 = ym2[0..3], ym2[4..5]

      for y in y1..y2
        for m in '01'..'12'
          next  if (y == y1 and m < m1)
          break if (y == y2 and m > m2)
          ndiary.makepastdiary(y + m)
        end
      end

    elsif argv[0].downcase == 'all' then
      ndiary.makepastdiary(:ALL)
      ndiary.makelastdiary

    else
      $stderr.puts "\n** Bad Parameter: '#{argv[0]}'\n"
      exit
    end
   
    # make topic list
    ndiary.maketopiclist

    puts "\nfinish. (#{Time::now - now}sec.)"

  rescue NDiaryFatalError
    $stderr.puts %Q|#{$!.message}\n(#{$!.class}: #{$@.join("\n")})\n|
  end
end

