#!/usr/local/bin/ruby
# amazon.rb  ver.0.4 2002.3.21-2003.1.20
# amazon.rb  ver.0.5 2003.5.20-2003.5.22
# amazon.rb  ver.0.6 2003.11.10 adultΉ
# amazon.rb  ver.0.6a 2003.11.28 oŎЏ̎C
# ISBN-search -> detail-parse
# original; isbn2bib.rb for bk1    by takahashi
#           amazon.rb   for amazon by not

#GfBVF  
#JX^}[r[ 
#̃̕fR[h܂B

require 'net/http'
require 'cgi'
#require 'simpleuri'
#require 'webagent'

class CacheBib_amazon < CacheBib
  attr_accessor :isbn
  attr_accessor :flag_review, :affiliate_code
  attr_accessor :url_site
  attr_accessor :title, :author, :publisher, :size, :pubdate, :price, :desc
  attr_accessor :image, :image_width, :image_height, :translator
  attr_accessor :reviews, :reviewlist
  attr_accessor :insystemKcode, :outputKcode, :messageKcode

  attr_accessor :asin

  def initialize ()
    super
    @reviews = Array.new()
    @flag_review = true
    @url_site = 'http://www.amazon.co.jp/'
    @affiliate_code = 'ipposjunkbox-22'
    @adult_check = true
    @insystemKcode = 3 #sjis #1-jis,2-euc,3-sjis
    @outputKcode   = 2 #euc
    @messagetKcode = 3 #sjis
  end

#===== ===== parts ===== =====
  def word_delivery ()
    delivery = ''
    flag = false
    # title-check -> no-info / get-info check
    if !@title.nil?
      flag = true
      if @delivery.nil?
        delivery = "Ȃ"
      else
        if @delivery =~ /24/
          delivery = "24"
        elsif @delivery =~ /2/
          delivery = "2"
        elsif @delivery =~ /3/
          delivery = "2`3"
        elsif @delivery =~ //
          delivery = ""
        elsif @delivery =~ /1`2T/
          delivery = "1`2T"
        else
          delivery = "H"
        end
      end
    else
      message = "WAR; maybe data-error, no-title."
      @stderr.puts message.kconv(@messageKcode)
    end
    return delivery, flag
  end

#===== ===== url ===== =====
  def url_bibinfo ()
    url = @url_site + "exec/obidos/ASIN/#{@asin}"
    url << "/ref_#{affiliate_code}" unless @affiliate_code.nil?
    url << '?val=authorized' unless @adult_check.nil?
    return url
  end

#===== ===== parse ===== =====
  def parse_bibinfo (str)
    #?̂keył킯Ăparse@?
    #----- parse -----

#    if %r|{̃f[^: (.+?)</title>|s =~ str then
    if %r|Amazon.co.jpF(.+?)</title>|sm =~ str then
      @title = $1.strip
      @title = @title.gsub(/^{:/s,'').strip
    end

    if %r|V[Yԍ: (.+?)\n|s =~ str then
      @series_num = $1
    end

    if %r|(<a href="/exec/obidos/search-handle-url/index=books-jp&field-author=[^\"]+">.+?<br>)| =~ str then
      authors = $1.split(/<a href=/)
      authors.each { |line|
        if %r|"/exec/obidos/search-handle-url/index=books-jp&field-author=[^\"]+">(.+?)</a>| =~ line then
          name = $1
          if line =~ /\(\)/ then
            if @author.nil? then @author = '' else @author << "\t" end
            @author << name
          elsif line =~ /\(\)/ then
            if @e_author.nil? then @e_author = '' else @e_author << "\t" end
            @e_author << name
          elsif line =~ /\(|\)/ then
            if @translator.nil? then @translator = '' else @translator << "\t" end
            @translator << name
          end
        end
      }
    end

    if %r|<b class="sans">.+?&nbsp;(.+?)</b>| =~ str
      @series = $1.gsub(/&nbsp;/,'').strip
    end

    if %r|<img src="http://images-jp.amazon.com/images/P/#{@asin}.09.MZZZZZZZ.jpg" width=(\d+) height=(\d+)| =~ str then
      @image = "http://images-jp.amazon.com/images/P/#{@asin}.09.MZZZZZZZ.jpg"
      @image_width  = $1.to_i
      @image_height = $2.to_i
    end

    if %r|<a href="http://images-jp.amazon.com/images/P/#{@asin}.09.LZZZZZZZ.jpg"| =~ str then
      @limage= "http://images-jp.amazon.com/images/P/#{@asin}.09.LZZZZZZZ.jpg"
    end

    if %r|iF\s*<font color=#990000>([\d,]+)</font></b><br>| =~ str then
      @price = $1
    end

    if %r|<b>\F</b>([^<]*?)<br>|mis =~ str then
      @delivery = $1.strip
    end

    if %r|<br clear="left">\n\n\n  \n<b>([^<]+)</b>\n(?: - (\d+) p)?|m =~ str then
      @size = $1
      @size << " #{$2}p" unless $2.nil?
    end

    if %r|^\(([\d\/]+)\)| =~ str then
      @pubdate = $1
    end

#    if %r|^([^>]+)\n ; \nISBN|m =~ str then
    if %r|<b>oŎ: </b>(.*?)\n|m =~ str then
      @publisher = $1.strip
    end

    if %r|ISBN:(.*?)\s*?;\s*?TCY|m =~ str then
      @isbn = $1.strip
    end

    if %r|TCY(.*?)\n|m =~ str then
      @pubsize = $1
    end

    if %r|<i>eiu.+?vf[^x[Xj</i></b> <br>  </font> +([^<]+)<BR>|s =~ str then
      @desc = $1
    end

    if str =~ /JX^}[r[<\/font>(.*)/ms
      data = $1
    end
#    reviewsplit = data.to_s.split("e")
    reviewsplit = data.to_s.split(/stars-.+?\.gif/)

    reviewlist = []
    reviewsplit.each{ |column|
      if column =~ /=review-id value=(\d+)/
        custid = $1
        reviewlist << custid
        if column =~ /e.*?<b>([^>]*?)<\/b>/m
          custid = $1.strip
          custid = "(noname)" if custid.size == 0
          reviewlist << custid
        end
      end
    }
    @reviewlist = reviewlist.join("\t") if reviewlist.size > 0

    if @flag_review
      reviewsplit.each{ |column|
        review = {}
        if column =~ /.+?alt=([^>]+?)>/
          review["value"] = $1
        end
        if column =~ /=review-id value=(\d+)/
          review["review-id"] = $1
        end
        if column =~ /^.*?<b>([^>]*?)<\/b>, ([\d\/]*)/
          review["title"] = $1.strip
          review["date"] = $2
        end
        if column =~ /e.*?<b>([^>]*?)<\/b>(.*?)<\/font><br>(.*?)<form/m
          reviewer = $1.strip
          reviewer = "(noname)" if reviewer.size == 0
          review["reviewer"] = reviewer
          review["place"] = $2.strip
          content = $3
          content.gsub!(/<br>/,"\n")
          content.gsub!(/\n\s+/,"\n")
          content.gsub!(/\s+/," ")
          content.gsub!(/\n+/,"\n")
          content.gsub!(/<P>/,"\n")
          content.strip!
          content.gsub!(/\n/,"\t")
          review["content"] = content
#          #?ƂイƂ?
        end
        @reviews << review if review.size > 0
      }
    end
   end

#===== ===== main ===== =====
  def set_info #===== set local-value from @info (from cache) =====
    #----- set book-info (from cache) -----
    @flag_overprint  = true if @info["overprint"]
    @asin            = @isbn.delete('-').upcase

    @title    = @info["title"]
    @delivery = @info["delivery"]
  end

  def get_info #===== get book-info(@info) from url =====
    message = 'CHK; access; ' + @url_site + ' -> ' + @isbn
    @stderr.puts message.kconv(@messageKcode)
    #----- get book-info -----
    agent = WebAgent.new()
    agent.uri = url_bibinfo
    agent.get()
    body = agent.body.kconv(@insystemKcode)
    parse_bibinfo(body)

    if !@flag_overprint
      @info = {}
    end
    @info["title"]        = @title
    @info["series_num"]   = @series_num
    @info["author"]       = @author
    @info["series"]       = @series
    @info["translator"]   = @translator
    @info["e_author"]     = @e_author
    @info["image"]        = @image
    @info["image_width"]  = @image_width
    @info["image_height"] = @image_height
    @info["limage"]       = @limage
    @info["price"]        = @price
    @info["delivery"]     = @delivery
    @info["size"]         = @size
    @info["pubdate"]      = @pubdate
    @info["publisher"]    = @publisher
    @info["isbn"]         = @isbn
    @info["pubsize"]      = @pubsize
    @info["desc"]         = @desc

    @info["reviewlist"] = @reviewlist

    @info["overprint"]  = true if @flag_overprint

    if @flag_review
      @info["reviews"] = @reviews
    end
  end
end
