#!/usr/bin/env ruby
# bk1.rb  ver.0.6 2002.3.21-2003.12.20
# ISBN-search -> detail-parse
# original; isbn2bib.rb for bk1 by takahashi
# R~bNΏƂƂȂꍇAʏƔɃtH[}bgςׁA̃f[^E˂ꍇLBΉB
# 2003.12.20 HTMĽ`ύXH@ɒǉB

require 'net/http'
require 'cgi'
#require 'cookie'
#require 'webagent'

class Review_bk1 #͖`FbN
  attr_accessor :url, :info
  attr_accessor :title, :reviewer_title, :reviewer, :date, :point, :content
  attr_accessor :insystemKcode, :outputKcode, :messageKcode

  def initialize ()
    @insystemKcode = 3 #sjis #1-jis,2-euc,3-sjis
    @outputKcode   = 2 #euc
    @messagetKcode = 3 #sjis
  end

  def parse_review (str)
    #----- set key and data ------
    mode_tbl = {
      '<!--]^Cg-->' => :title,
      '<!--]Ҍ-->'   => :reviewer_title,
      '<!--]Җ-->'     => :reviewer,
      '<!--]-->'       => :date,
      '<!--ǎҕ]l-->'   => :point,
      '<!--]-->'         => :content,
      '<!--ǎҏ]Ȃ^{^\-->' => :none
    }
    mode = :none
    data = Hash.new()

    #----- read and sepalate by key(mode_tbl) ------
    str.each{|line|
      l = line.chomp.chomp("\r").kconv(@insystemKcode)
      l.strip!
      if mode_tbl[l]
	mode = mode_tbl[l]
      end
      if mode != :none
	if data[mode]
	  data[mode] << line
	else
	  data[mode] = line
	end
      end
    }

    #----- parse -----
    @title          = data[:title].to_s.gsub(/<[^>]+>/,'').strip
    @reviewer_title = data[:reviewer_title].to_s.gsub(/<[^>]+>/,'').strip
    @reviewer       = data[:reviewer].to_s.gsub(/<[^>]+>/,'').strip
    @date           = data[:date].to_s.gsub(/<[^>]+>/,'').strip
    @point          = data[:point].to_s.gsub(/<[^>]+>/,'').sub(/]i}[Nj/s,'').sub(/@/s,'').strip
    @content        = data[:content].to_s.gsub(/<[^>]+>/,'').strip
    @content.gsub!(/\n/,"\t")
  end

  def get_review ()
    agent = WebAgent.new()
    agent.uri = @url
    agent.get()
    body = agent.body.kconv(@insystemKcode)
    parse_review(body)

    @info = {}
    @info["title"]        = @title
    @info["review_title"] = @reviewer_title
    @info["review"]       = @reviewer
    @info["date"]         = @date
    @info["point"]        = @point
    @info["content"]      = @content
  end
end

class CacheBib_bk1 < CacheBib
  attr_accessor :isbn
  attr_accessor :flag_review, :affiliate_code
  attr_accessor :url_site
  attr_accessor :title, :author, :publisher, :size, :pubdate, :price, :desc
  attr_accessor :image, :delivery
  attr_accessor :reviews, :reviewlist
  attr_accessor :chiefeditor, :author_intro, :series
  attr_accessor :author_auid, :translator_auid, :chiefeditor_auid
  attr_accessor :flag_image, :dir_image, :url_image
  attr_accessor :insystemKcode, :outputKcode, :messageKcode

  attr_accessor :bibid

  def initialize ()
    super
    @reviews = Array.new()
    @flag_review = true
    @url_site = 'http://www.bk1.co.jp/'
    @affiliate_code = 'p-ippo57167'
    @flag_image = true #false
    @dir_image = '../www/'
    @url_image = './'
    @insystemKcode = 3 #sjis #1-jis,2-euc,3-sjis
    @outputKcode   = 2 #euc
    @messagetKcode = 3 #sjis
  end

#===== ===== parts ===== =====
  def word_delivery ()
    delivery = ''
    flag = false
    # title-check -> no-info / get-info check
    if !@title.nil?
      flag = true
      if @delivery.nil?
        delivery = "Ȃ"
      else
        if @delivery =~ /24/
          delivery = "24"
        elsif @delivery =~ /3/
          delivery = "2`3"
        elsif @delivery =~ //
          delivery = ""
        else
          delivery = "H"
        end
      end
    else
      message = "WAR; maybe data-error, no-title."
      @stderr.puts message.kconv(@messageKcode)
    end
    return delivery, flag
  end

#===== ===== url ===== =====
  def url_isbnsearch ()
    url = @url_site + "cgi-bin/srch/srch_result_book.cgi/?"
    url << "isbn=#{@isbn}"
    url << "&aid=#{@affiliate_code}" if !@affiliate_code.nil?
    url << "&idx=3"
    return url
  end

  def url_bibinfo ()
    url = @url_site + "cgi-bin/srch/srch_detail.cgi/?"
    url << "bibid=#{@bibid}"
    url << "&aid=#{@affiliate_code}" if !@affiliate_code.nil?
    url << "&idx=3"
    return url
  end

  def url_review ()
    url = @url_site + "cgi-bin/srch/srch_rev.cgi/?"
    url << "bibid=#{@bibid}&volno=#{@volno}&revid=#{@revid}"
    url << "&aid=#{@affiliate_code}" if !@affiliate_code.nil?
    return url
  end

#===== ===== parse ===== =====
  def parse_isbnsearch (str)
    count = 0
    str.scan(%r|\s*<a href="/cgi-bin/srch/srch_detail.cgi/.*\?.*&bibid=(\d+)&.*">(.*)</a>|){
      @bibid, @title = $1, $2
      if @bibid.nil?
        @title = nil
      else
        count = count + 1
      end
    }
    if count > 1
      message = "WAR; ISBN-search hit multi-column. ISBN; " + @isbn
      @stderr.puts message.kconv(@messageKcode)
    end
  end

  def parse_bibinfo (str)
    #----- set key and data ------
    mode_tbl = {
      '<!-- 摜\ -->'     => :image,
      '<!--Ж\-->'     => :title,
      '<!-- Җ\ -->'   => :author,
      '<!--oŎЁETCYEISBNEsN-->' => :p_s_i_d,
      '<!--i-->'       => :price_shubetsu,
      '<!--i-->'           => :price,
      '<!--pΏ-->'       => :none,
      '<!-- [ACR -->' => :delivery,
      '<!--؂-->'       => :content,
      ' <!-- ҏЉ0łȂΕ\-->' => :comment, 
      '<!-- Ir -->'         => :none,
      '<!--ҏ]{-->'   => :review,
      '<!--ǎҏ]-->'       => :review
    }
    mode = :none
    data = Hash.new()
    
    #----- bibinfo-area ------
    str = str.scan(%r|<!-- %Cut Start% -->(.+)<!-- %Cut End% -->|mi).join
    tables = str.scan(%r|<tr>.*?</tr>|mi)
    
    #----- parse -----
    if tables[0] =~ %r|<img src="(.*?)"|
      image = $1
      if image !~ /no_img/
        @image = @url_site.chomp('/') + image
      end
    end
    
    titles = tables[0].scan(%r|<b>(.*?)</b>|)
    @title = titles[0] unless titles[0].nil?
    if !titles[-1].nil? && titles[-1].to_s.strip =~ /^\((.*?)\)$/
      @label = $1.strip
      if @label =~ /^(.*?)\s(.*)$/
        @label, @series = $1, $2
      end
    end
#    data[:title] =~ Regexp.new("<b>([^<]*)</b>")
    
    authors = []
    tables[1].scan(%r|<a href="/cgi-bin/srch/srch_result_book.cgi/.*?&auid=(\d+)">(.*?)</a>|){ |code, name|
      authors << [code, name]
    }
    authors.each { |auid, name_str|
#      str = line.to_s.gsub(/<[^>]+>/,'').delete("\n").strip
      if name_str =~ /($|$)/ #|kl$
        name = $`
          name += ''if name_str =~ /$/
          if @author.nil? then @author = '' else @author << "\t" end
          @author << name
          if @author_auid.nil? then @author_auid = '' else @author_auid << "\t" end
          @author_auid << auid
      elsif name_str =~ /$/
        name = $`
        if @translator.nil? then @translator = '' else @translator << "\t" end
        @translator << name
        if @translator_auid.nil? then @translator_auid = '' else @translator_auid << "\t" end
        @translator_auid << auid
      elsif str =~ /ďC$/
        name = $`
        if @chiefeditor.nil? then @chiefeditor = '' else @chiefeditor << "\t" end
        @chiefeditor << name
        if @chiefeditor_auid.nil? then @chiefeditor_auid = '' else @chiefeditor_auid << "\t" end
        @chiefeditor_auid << auid
      end
    }
    
    if tables[1] =~ %r|{̉iF(.*?)<br>|
      @price = $1.strip
    end
    if tables[1] =~ %r|oŁF(.*?)<br>|
      @publisher = $1.strip
    end
    if tables[1] =~ %r|TCYF(.*?)<br>|
      @size = $1.strip
    end
    if tables[1] =~ %r|ISBNF(.*?)<br>|
      @isbn = $1.strip
    end
    if tables[1] =~ %r|sNF(.*?)<br>|
      @pubdate = $1.strip
    end
    if tables[1] =~ %r|pΏہF(.*?)<br>|
      @user = $1.delete("@").strip
    end
    
    if tables[1] =~ %r|\.*?<img src="/images/.*?alt="(.*?)"|mi
      @delivery = $1
    end
    
    #-----no-check-----
    data = {}
    data[:content] = str
    data[:comment] = str
    data[:review]  = str
=begin
    if !data[:content].nil?
      if data[:content] =~ /e/s
        desc = data[:content].to_s.sub(/.*<b>e<\/b>/s, '').sub(/@/s,'').sub(/<!--space-->.*/,'').gsub(/<[^>]+>/,'').strip
        @desc = desc if desc.size > 0
      end
    end
=end
    
=begin
    if !data[:comment].nil?
      authors = data[:comment].gsub(/<!-- =====ҏ]end===== -->.*/,'').split('<!--space-->')
      authors.each { |line|
        intro = line.sub(/.*<b>ҏЉ<\/b>/s, '').gsub(/@/e,'').gsub(/<[^>]+>/,'').strip
        if intro.size > 0
          if @author_intro.nil? then @author_intro = '' else @author_intro << "\t" end
          @author_intro << intro
        end
      }
    end
=end
    
    revlist1 = []
    data[:review].to_s.scan(%r|̏]͍w̎QlɂȂ܂H(.*?)|) {|ids|
        revid = ids[0].scan(/name="revid" value="(\d+)"/)[0]
        revlist1 << revid
    }
    revlist2 = []
    data[:review].to_s.scan(%r|<a href="/cgi-bin/srch/srch_result_rev.cgi/[^?]*?([^"]*?".*?</a>)|) {|ids|
        revstr = ids[0].scan(/>(.*?)<\/a>/)[0]
        revlist2 << revstr
    }
    reviewlist = []
    revlist1.each_index { |i|
      reviewlist << revlist1[i]
      reviewlist << revlist2[i]
    }
    @reviewlist = reviewlist.join("\t") if reviewlist.size > 0
    
    if @flag_review
      data[:review].to_s.scan(%r|̏]͍w̎QlɂȂ܂H(.*?)|){ |ids|
          @volno = ids[0].scan(/name="volno" value="(\d+)"/)[0]
          @revid = ids[0].scan(/name="revid" value="(\d+)"/)[0]
          review = Review_bk1.new()
          review.url = url_review
          review.get_review
          @reviews << review.info
      }
    end
  end

#===== ===== main ===== =====
  def set_info #===== set local-value from @info (from cache) =====
    #----- set book-info (from cache) -----
    @flag_overprint  = true if @info["overprint"]
    @bibid           = @info["bibid"]
    @flag_isbnsearch = true if !@bibid
    
    @title    = @info["title"]
    @delivery = @info["delivery"]
  end

  def get_info #===== get book-info(@info) from url =====
    message = 'CHK; access; ' + @url_site + ' -> ' + @isbn
    @stderr.puts message.kconv(@messageKcode)
    #----- get detail-code -----
    if @flag_isbnsearch
      agent = WebAgent.new()
      agent.uri = url_isbnsearch
      agent.get()
      body = agent.body.kconv(@insystemKcode)
      parse_isbnsearch(body)
    end
    
    #----- get book-info -----
    agent = WebAgent.new()
    agent.uri = url_bibinfo
    agent.get()
    body = agent.body.kconv(@insystemKcode)
    isbn_bkup = @isbn.dup
    parse_bibinfo(body)
    
    #----- get book-image -----
    if !@image.nil? && @flag_image
#      filename = @dir_image + File.basename(@image)
      isbn = @isbn
      isbn = isbn_bkup if isbn.nil?
      filename = @dir_image + 'isbn' + isbn.delete('-').downcase + '.jpg'
      urlname  = @url_image + 'isbn' + isbn.delete('-').downcase + '.jpg'
      unless File.exist?(filename)
        $stderr.puts "CHK; download-image; #{@image} -> #{filename}"
        agent = WebAgent.new()
        agent.uri = @image
        agent.get()
        open(filename, 'wb').write(agent.body)
        @image_local = urlname
      else
        @image_local = urlname
      end
    end
    if !@image_local.nil?
      isbn = @isbn
      isbn = isbn_bkup if isbn.nil?
      filename = @dir_image + 'isbn' + isbn.delete('-').downcase + '.jpg'
      if File.exist?(filename)
        require 'lib/imagesize'
        w, h = ImageSize::size(filename)
        @image_width, @image_height = w, h unless w.zero?
      end
    end
    
    if !@flag_overprint
      @info = {}
    end
    @info["image"]      = @image
    @info["image_width"]  = @image_width
    @info["image_height"] = @image_height
    @info["image_local"] = @image_local
    @info["title"]      = @title
    @info["author"]     = @author
    @info["translator"] = @translator
    @info["publisher"]  = @publisher
    @info["size"]       = @size
    @info["isbn"]       = @isbn
    @info["pubdate"]    = @pubdate
    @info["price"]      = @price
    @info["delivery"]   = @delivery
    @info["desc"]       = @desc
    
    @info["bibid"]      = @bibid
    @info["reviewlist"] = @reviewlist
    @info["chiefeditor"]      = @chiefeditor
    @info["author_auid"]      = @author_auid
    @info["translator_auid"]  = @translator_auid
    @info["chiefeditor_auid"] = @chiefeditor_auid
    @info["author_intro"]     = @author_intro
    @info["series"]           = @series
    @info["label"]            = @label
    @info["user"]             = @user
    
    @info["overprint"]  = true if @flag_overprint
    
    if @flag_review
      info["reviews"] = @reviews
    end
  end
end
