#!/usr/bin/env ruby
# bk1.rb  ver.0.6 2002.3.21-2003.12.22
# ISBN-search -> detail-parse
# original; isbn2bib.rb for bk1 by takahashi
# R~bNΏƂƂȂꍇAʏƔɃtH[}bgςׁA̃f[^E˂ꍇLBΉB
# 2003.12.20 HTMĽ`ύXH@ɒǉB]͂܂ΉB
# 2003.12.20ȑOcache.rbp

require 'net/http'
require 'cgi'
#require 'cache'
#require 'cookie'
#require 'webagent'

class Review_bk1 #͖ύX̗lq
  attr_accessor :url, :info
  attr_accessor :title, :reviewer_title, :reviewer, :date, :point, :content
  attr_accessor :insystemKcode, :outputKcode, :messageKcode
  
  def initialize ()
    @insystemKcode = 3 #sjis #1-jis,2-euc,3-sjis
    @outputKcode   = 2 #euc
    @messagetKcode = 3 #sjis
  end
  
  def parse_review (str)
    #----- set key and data ------
    mode_tbl = {
      '<!--]^Cg-->' => :title,
      '<!--]Ҍ-->'   => :reviewer_title,
      '<!--]Җ-->'     => :reviewer,
      '<!--]-->'       => :date,
      '<!--ǎҕ]l-->'   => :point,
      '<!--]-->'         => :content,
      '<!--ǎҏ]Ȃ^{^\-->' => :none
    }
    mode = :none
    data = Hash.new()
    
    #----- read and sepalate by key(mode_tbl) ------
    str.each{|line|
      l = line.chomp.chomp("\r").kconv(@insystemKcode)
      l.strip!
      if mode_tbl[l]
        mode = mode_tbl[l]
      end
      if mode != :none
        if data[mode]
          data[mode] << line
        else
          data[mode] = line
        end
      end
    }
    
    #----- parse -----
    @title          = data[:title].to_s.gsub(/<[^>]+>/,'').strip
    @reviewer_title = data[:reviewer_title].to_s.gsub(/<[^>]+>/,'').strip
    @reviewer       = data[:reviewer].to_s.gsub(/<[^>]+>/,'').strip
    @date           = data[:date].to_s.gsub(/<[^>]+>/,'').strip
    @point          = data[:point].to_s.gsub(/<[^>]+>/,'').sub(/]i}[Nj/s,'').sub(/@/s,'').strip
    @content        = data[:content].to_s.gsub(/<[^>]+>/,'').strip
    @content.gsub!(/\n/,"\t")
  end
  
  def get_review ()
    agent = WebAgent.new()
    agent.uri = @url
    agent.get()
    body = agent.body.kconv(@insystemKcode)
    parse_review(body)
    
    @info = {}
    @info["title"]        = @title
    @info["review_title"] = @reviewer_title
    @info["reviewer"]     = @reviewer
    @info["date"]         = @date
    @info["point"]        = @point
    @info["content"]      = @content
  end
end

class CacheBib_bk1 < CacheBib
  attr_accessor :isbn
  attr_accessor :flag_review, :affiliate_code
  attr_accessor :url_site
  attr_accessor :title, :author, :publisher, :size, :pubdate, :price, :desc
  attr_accessor :image, :delivery
  attr_accessor :reviews, :reviewlist
  attr_accessor :chiefeditor, :author_intro, :series
  attr_accessor :author_auid, :translator_auid, :chiefeditor_auid
  attr_accessor :flag_image, :dir_image, :url_image
  attr_accessor :insystemKcode, :outputKcode, :messageKcode
  
  attr_accessor :bibid
  
  def initialize ()
    super
    @reviews = Array.new()
    @flag_review = true
    @url_site = 'http://www.bk1.co.jp/'
    @affiliate_code = 'p-ippo57167'
    @flag_image = false #false #ŉ摜_E[hON/OFF
    @dir_image = './' #'../www/'
    @url_image = './'
    @insystemKcode = 3 #sjis #1-jis,2-euc,3-sjis
    @outputKcode   = 2 #euc
    @messagetKcode = 3 #sjis
  end
  
  #===== ===== parts ===== =====
  def word_delivery ()
    delivery = ''
    flag = false
    if !@title.nil? # title-check -> no-info / get-info check
      flag = true
      if @delivery.nil?
        delivery = "Ȃ"
      else
        if @delivery =~ /24/
          delivery = "24"
        elsif @delivery =~ /3/
          delivery = "2`3"
        elsif @delivery =~ //
          delivery = ""
        else
          delivery = "H"
        end
      end
    else
      message("WAR; maybe data-error, no-title.")
    end
    return delivery, flag
  end
  
  #===== ===== url ===== =====
  def url_isbnsearch ()
    url = @url_site + "cgi-bin/srch/srch_result_book.cgi/?"
    url << "isbn=#{@isbn}"
    url << "&aid=#{@affiliate_code}" if !@affiliate_code.nil?
    url << "&idx=3"
    return url
  end
  
  def url_bibinfo ()
    url = @url_site + "cgi-bin/srch/srch_detail.cgi/?"
    url << "bibid=#{@bibid}"
    url << "&aid=#{@affiliate_code}" if !@affiliate_code.nil?
    url << "&idx=3"
    return url
  end
  
  def url_review ()
    url = @url_site + "cgi-bin/srch/srch_rev.cgi/?"
    url << "bibid=#{@bibid}&volno=#{@volno}&revid=#{@revid}"
    url << "&aid=#{@affiliate_code}" if !@affiliate_code.nil?
    return url
  end
  
  def url_authorinfo ()
    url = @url_site + "cgi-bin/srch/srch_result_book.cgi/?"
    url << "auid=#{@author_id}"
    url << "&aid=#{@affiliate_code}" if !@affiliate_code.nil?
    url << "&srch=4"
    return url
  end
  
  #===== ===== parse ===== =====
  def parse_isbnsearch ( str )
    count = 0
    str.scan(%r|\s*<a href="/cgi-bin/srch/srch_detail.cgi/.*\?.*&bibid=(\d+)&.*">(.*)</a>|){
      @bibid, @title = $1, $2
      if @bibid.nil?
        @title = nil
      else
        count = count + 1
      end
    } #݂ꍇŊɌ̂L
    if count > 1
      message("WAR; ISBN-search hit multi-column. ISBN; " + @isbn)
    end
  end
  
  def parse_bibinfo (str)
    #----- bibinfo-area ------
    str_pre, str_post = '', ''
    if str =~ %r|<!-- %Cut Start% -->.+<!-- %Cut End% -->|mi
      str_pre, str, str_post = $`, $&, $'
    end
    tables = str.scan(%r|<tr>.*?</tr>|mi)
    
    #----- parse -----
    if tables[0] =~ %r|<img src="(.*?)"|
      image = $1
      if image !~ /no_img/
        @image = @url_site.chomp('/') + image
      end
    end
    
    titles = tables[0].scan(%r|<b>(.*?)</b>|)
    @title = titles[0] unless titles[0].nil?
    if !titles[-1].nil? && titles[-1].to_s.strip =~ /^\((.*?)\)$/
      @label = $1.strip
      if @label =~ /^(.*?)\s(.*)$/
        @label, @series = $1, $2
      end
    end
#    data[:title] =~ Regexp.new("<b>([^<]*)</b>")
    
    authors = []
    tables[1].scan(%r|<a href="/cgi-bin/srch/srch_result_book.cgi/.*?&auid=(\d+)">(.*?)</a>|){ |code, name|
      authors << [code, name]
    }
    authors.each { |auid, name_str|
#      str = line.to_s.gsub(/<[^>]+>/,'').delete("\n").strip
      if name_str =~ /($|$|kl$)/
        name = $`
          name += ''if name_str =~ /$/
          if @author.nil? then @author = '' else @author << "\t" end
          @author << name
          if @author_auid.nil? then @author_auid = '' else @author_auid << "\t" end
          @author_auid << auid
      elsif name_str =~ /$/
        name = $`
        if @translator.nil? then @translator = '' else @translator << "\t" end
        @translator << name
        if @translator_auid.nil? then @translator_auid = '' else @translator_auid << "\t" end
        @translator_auid << auid
      elsif name_str =~ /ďC$/
        name = $`
        if @chiefeditor.nil? then @chiefeditor = '' else @chiefeditor << "\t" end
        @chiefeditor << name
        if @chiefeditor_auid.nil? then @chiefeditor_auid = '' else @chiefeditor_auid << "\t" end
        @chiefeditor_auid << auid
      end
    }
    
    if tables[1] =~ %r|{̉iF(.*?)<br>|mi
      @price = $1.strip
    end
    if tables[1] =~ %r|oŁF(.*?)<br>|mi
      @publisher = $1.strip
    end
    if tables[1] =~ %r|TCYF(.*?)<br>|mi
      @pubsize = $1.strip
    end
    if tables[1] =~ %r|ISBNF(.*?)<br>|mi
      @isbn = $1.strip
    end
    if tables[1] =~ %r|sNF(.*?)<br>|mi
      @pubdate = $1.strip
    end
    if tables[1] =~ %r|pΏہF(.*?)<br>|mi
      @user = $1.delete("@").gsub(/\s+/,'').gsub(/<!--.*?-->/,'').strip
    end
    
    if tables[1] =~ %r|\.*?<img src="/images/.*?alt="(.*?)"|smi
      @delivery = $1
    end #FR[hoption(SJIS)Ƒʖڂȏꍇ
    
    if tables[1] =~ %r|OkiDokiΏ|
      @okidoki = true
    end
    
    if str =~ %r|e(.+?)<hr|mi
      @desc = $1.gsub(/<[^>]+>/,'').gsub(/\s+/, ' ').strip
#      @desc = desc if desc.size > 0
    end
    
    str_post.scan(%r|ҏЉ(.+?)<hr|mi){ |intro|
      intro = $1.gsub(/<[^>]+>/,'').gsub(/\s+/, ' ').strip
      if @author_intro.nil? then @author_intro = '' else @author_intro << "\t" end
      @author_intro << intro
    }
    
    #-----review-----
    reviewlist = []
    str_post.scan(%r|<b>oŎЃRg</b>.+?<a href="/cgi-bin/srch/srch_result_rev.cgi/.+?>(.+?)</a>|mi){ |nick|
      reviewlist << 'oŎЃRg'
      reviewlist << nick
    }
    str_post.scan(%r|<b>eЉ</b>.+?<a href="/cgi-bin/srch/srch_result_rev.cgi/.+?>(.+?)</a>|mi){ |nick|
      reviewlist << 'eЉ'
      reviewlist << nick
    }
    str_post.scan(%r|]</b>.+?<a href="/cgi-bin/srch/srch_result_rev.cgi/.+?>(.+?)</a>|mi){ |nick|
      reviewlist << ']'
      reviewlist << nick
    }
    @reviewlist = reviewlist.join("\t") if reviewlist.size > 0
    
    if @flag_review
      str_post.scan(%r|<a href="/cgi-bin/srch/srch_rev.cgi.+?volno=(\d+).+?revid=(\d+)|mi){ |volno, revid|
        @volno, @revid = volno, revid
        review = Review_bk1.new()
        review.url = url_review
        review.get_review
        @reviews << review.info
      }
    end
  end
  
  #===== ===== get/set info ===== =====
  def set_info #===== set local-value from @info (from cache) =====
    #----- set book-info (from cache) -----
    @flag_overprint  = true if @info["overprint"]
    @bibid           = @info["bibid"]
    @bibid           = @info["id"] unless @info['id'].nil?
    @flag_isbnsearch = true if !@bibid
    @author_id = @info['author_id'] if @author_id.nil?
    
    @title    = @info["title"]
    @delivery = @info["delivery"]
  end
  
  def get_info #===== get book-info(@info) from url =====
    message('CHK; access; ' + @url_site + ' -> ' + @isbn)
    #----- get detail-code -----
    if !@id
      agent = WebAgent.new()
      agent.uri = url_isbnsearch
      agent.get()
      body = agent.body.kconv(@insystemKcode)
      parse_isbnsearch(body)
    end
    #----- get book-info -----
    agent = WebAgent.new()
    agent.uri = url_bibinfo
    agent.get()
    body = agent.body.kconv(@insystemKcode)
#    isbn_bkup = @isbn.dup
    parse_bibinfo(body)
    #----- get book-image -----
    if !@image.nil? && @flag_image
#      filename = @dir_image + File.basename(@image)
      isbn = @isbn
#      isbn = isbn_bkup if isbn.nil?
#      ext = File.extname(@image)
      ext = '.jpg'
      if @image =~ /(\.+?)$/
        ext = $1.strip
      end
      filename = @dir_image + 'isbn' + isbn.delete('-').downcase + ext
      urlname  = @url_image + 'isbn' + isbn.delete('-').downcase + ext
      unless File.exist?(filename)
        message("CHK; download-image; #{@image} -> #{filename}")
        agent = WebAgent.new()
        agent.uri = @image
        agent.get()
        open(filename, 'wb').write(agent.body)
        @image_local = urlname
      else
        @image_local = urlname
      end
    end
    if !@image_local.nil?
      isbn = @isbn
#      isbn = isbn_bkup if isbn.nil?
      ext = '.jpg'
      if @image_local =~ /(\.+?)$/
        ext = $1.strip
      end
      filename = @dir_image + 'isbn' + isbn.delete('-').downcase + ext
      if File.exist?(filename)
        require 'imagesize'
        w, h = ImageSize::size(filename)
        @image_width, @image_height = w, h unless w.zero?
      end
    end
    set_info_to_info
  end
  
  def set_info_to_info #===== set book-info(@info) from local-value =====
    #----- set info -----
    @flag_download        = true
    @info["isbn"]       = @isbn
#    @info["code"]         = @code #ISBNƏd
#    @info["id"]           = @id #bibid
    @info["title"]        = @title
    @info["series"]       = @series
    @info["label"]        = @label
    @info["author"]       = @author
    @info["publisher"]    = @publisher
    @info["pubcode"]      = @pubcode
    @info["pubdate"]      = @pubdate
    @info["pubsize"]      = @pubsize
    @info["price"]        = @price
    @info["desc"]         = @desc
    @info["delivery"]     = @delivery
    @info["image"]        = @image
    @info["image_width"]  = @image_width
    @info["image_height"] = @image_height
    @info["image_local"]  = @image_local
    @info["translator"]   = @translator
    @info["e_title"]      = @e_title
    @info["e_author"]     = @e_author
    @info["e_pubdate"]    = @e_pubdate
    @info["reviews"]      = @reviews if @flag_review
#    @info["hold_keys"]    = @hold_keys.join(' ') #read_cacheŃZbgĂ
    @info["overprint"]    = true if @flag_overprint
    
    #----- set info add ----- #bk1Ǝ̏
    @info["bibid"]      = @bibid
    @info["reviewlist"] = @reviewlist
    @info["chiefeditor"]      = @chiefeditor
    @info["author_auid"]      = @author_auid
    @info["translator_auid"]  = @translator_auid
    @info["chiefeditor_auid"] = @chiefeditor_auid
    @info["author_intro"]     = @author_intro
  end
  
  def message ( str = '???: message-error.', kcode = @messageKcode )
    @stderr.puts str.kconv(kcode)
  end
  
  #+++++++++++ ippo ************
  #===== ===== url ===== =====
  def url_ippo_bibinfo ()
    url = 'http://ippo.itbdns.com/cgi/cache/bookcache.cgi?'
    url << "shop=bk1;"
    url << "isbn=#{@isbn}"
    return url
  end
  
  #===== ===== parse ===== =====
  def parse_ippo_bibinfo ( str )
    read_cache_ippo(str)
    @flag_download = true
  end
  
  def read_cache_ippo ( str = nil ) # ( @file, @flag, @info, @hold_keys )
    if @flag #----- already read cache -----
      message("WAR; cache-reread-request. already readed. FILE; " + @file.to_s)
      return
    end
    
    begin
      #----- \n\n-sepalate -----
      texts = []
      text = []
      str = open(@file).read if str.nil?
      str.each{ |line|
        string = (line.chomp.chomp("\r")).kconv(@insystemKcode)
        if string != ""
          text << string
        else
          texts << text
          text = []
        end
      }
      texts << text
      
      #----- book-info -----
      texts.shift.each{ |line|
        record = line.split(/\t/)
        key = record.shift
        data = record.join("\t")
        @info[key] = data
      }
      
      #----- review-info -----
      if texts.size > 0
        reviews = []
        texts.each{ |text|
          reviewinfo = {}
          text.each { |line|
            record = line.split(/\t/)
            key = record.shift
            data = record.join("\t")
            reviewinfo[key] = data
          }
          reviews << reviewinfo
        }
        @info["reviews"] = reviews
      end
      
      #----- hold-keys-info -----
      unless @info["hold_keys"].nil?
        @hold_keys = @info["hold_keys"].split
      end
      @flag = true #cacheǍσtON
    rescue
      message("CHK; cannot read cahce. FILE; " + @file.to_s)
      @flag = nil
    end
  end
  
  #===== ===== get/set info ===== =====
#RgAEgƁAbk1ȂȂB
=begin
  alias :orig_get_info :get_info
  def get_info #===== get book-info(@info) from url =====
    begin
      message('CHK; access; ' + 'http://ippo.itbdns.com/cgi/cache/ bk1' + ' -> ' + @isbn)
      #----- get book-info -----
      agent = WebAgent.new()
      agent.uri = url_ippo_bibinfo
      agent.get()
      body = agent.body.kconv(@insystemKcode)
      parse_ippo_bibinfo(body)
      set_info
    rescue
      orig_get_info
    end
  end
=end
end
